<?php

namespace Slovocast\Infrastructure\Database;

use React\Mysql\MysqlClient;
use Slovocast\Infrastructure\Api\Database\ConnectionPoolInterface;
use Slovocast\Infrastructure\Api\Database\PooledConnectionInterface;

class ConnectionPool implements ConnectionPoolInterface
{
    /**
     * Set a default wait timeout for acquiring a connection to 100ms
     */
    const int DEFAULT_WAIT_TIMEOUT = 100;
    private array $idleConnections;
    private array $activeConnections;
    private ConnectionPoolConfig $config;

    public function __construct(ConnectionPoolConfig $config)
    {
        $this->config = $config;
        for ($i = 0; $i < $config->getTotalConnections(); $i++) {
            $this->idleConnections[] = new MysqlClient($this->config->getDsn());
        }
    }

    public function getTotalIdleConnections(): int
    {
        // TODO: Implement getTotalIdleConnections() method.
    }

    public function getTotalActiveConnections(): int
    {
        // TODO: Implement getTotalActiveConnections() method.
    }

    public function hasIdleConnection(): bool
    {
        // TODO: Implement hasIdleConnection() method.
    }

    public function setWaitTimeout(int $seconds): void
    {
        // TODO: Implement setWaitTimeout() method.
    }

    public function getWaitTimeout(): int
    {
        // TODO: Implement getWaitTimeout() method.
    }

    public function getConnectionLimit(): int
    {
        // TODO: Implement getConnectionLimit() method.
    }

    public function getConnection(): PooledConnectionInterface
    {
        // TODO: Implement getConnection() method.
    }

    public function releaseConnection(PooledConnectionInterface $connection): void
    {
        // TODO: Implement releaseConnection() method.
    }
}
